﻿Type=Service
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'STARTER Service: This is App Process Only one Entry Point 
'包含: UDP Service與 DBservice 功能
'This Service name must be Starter(IDE automatically created by default)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#Region  Service Attributes 
	#StartAtBoot: False
	'Starter service must be excluded from libraries. Attribute set To True by default.
	#ExcludeFromLibrary: True
#End Region
Sub Process_Globals
	Type	CallBackDef(Callback_SubName As String,UI_Row As Long, rTag As String,args() As Object, TableViewIdx As Int)
	'---------------------------------------------------------------------------
	'Global format, must be set; SQL Server default must adapt this format
 	'SQLite INSERT/UPDATE/DELETE SQL must set Datetime to 'yyyy-MM-dd HH:mm:ss'
	'---------------------------------------------------------------------------
	DateTime.DateFormat = "yyyy-MM-dd"		'case-sensitive
	DateTime.TimeFormat = "HH:mm:ss"
	
	Public	eAILib				As eAIFAILib
	Public	regMgr				As eAIRegMgr
	
	Public	gs_RegFile			As String	= "preparemtlreg.txt"	'Unix is case-sensitive
	Public	gb_Debug			As Boolean	= False
	Public	gs_Customer			As String	= ""					'Taiwan Diamond Company		
	Public	gs_SysID			As String	= "PrepareMtl"
	Public	gs_SysName			As String	= "生產備料作業"
	Public	gs_MyPkgName		As String	= ""					'eAI.MES.MTL.PrepareMtl
	Public	gs_BuildID			As String	= ""
	Public	gs_ResetFlag 		As String	= "resetpkg.txt" 		'For reset to factory setting
	Public	gb_Reset			As Boolean	= False
	Public	gs_SysMenu			As String	= "" 					'always return to this portal
	Public	gs_SQLGatewayURL	As String	'Jetty URL
	Public	gs_SQLite_DBname 	As String	'registry
	
	Public	gi_PID()			As Long		= Array As Long(0,0)	'PID & PPID
	Public	gi_DaysAfter		As Int		= 7
	Public	gi_DaysBefore		As Int		= 3
	Public	gs_StartDate		As String	= ""
	Public	gs_EndDate			As String	= ""
	'.............................................................................
	'Printer List UDP packet sent by MESserver by getting installed Printer
	'Printer is selectable by user and save Registry as next Default
	'.............................................................................
	Public	gs_MyPrinterID		As String	= ""	'save last selected in registry
	Public	gs_MyScaleID		As String	= ""	'save last selected in registry
	Public	gs_LableFormat		As String	= ""	'Registry defined
'	Public	gi_NumOfCopies		As Int	= 1
'	Public	gi_MaxNumOfCopies	As Int
	'...................................................................
	'UDP_Service
	'...................................................................
	Public	gs_ServerIP			As String 	= "192.168.0.100"
	Public	gi_ServerPort		As Int 		= 19500
	Public	gi_LocalPort		As Int		= 19502
	
	Public	gcb_CallBack		As CallBackDef		'CallBackDef defined in Starter
	Public	UDP_Socket			As UDPSocket
	Public	UDP_Packet			As UDPPacket
	Public	gb_UDP_Ready		As Boolean	= False
	Public	gs_WightPktPreFix	As String	="cLi"	'UDP packet prefix for weighing client
	'...................................................................
	'DBservice: SQL 2008 DB Server
	'Local SQLite DB to store Query Result from Remote SQL Data
	'SQLite will be cleared for each Query
	'SQL Server: 172.16.10.51  Database: Mobile  login: b4a / a123456!
	'Internet access:
	'1. http://b4aJettySvr.eai.com.tw:17178  (Public IP:124.219.81.145)
	'2. RDC Server (Development:VICTORHUANG NoteBook)
	'    E:\B4A\1proj\RDC\RDC-Server\RemoteDatabaseConnector
	'    Configuration file: config.properties
	'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	'!!!  Causion!! Jetty Web Server only work for JAVA JRE 8.0_40   !!!
	'!!!! Causing!! JRE 8.0_60 failed to connect !!!!!!!!!!!!!!!!!!!!!!!
	'RDC is based on Jetty 7.4.2 no further update
	'!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	'	....................................................................
	'Me: callback To This Module
	'Database: JdbcUrl=jdbc:jtds:sqlserver://localhost/TDCMES
	'User=b4a /a123456! ServerPort=17178
	'gs_SQLGatewayURL= "http://192.168.0.100:17178"  'Jettwy Web Server 
	'gs_SQLGatewayURL= "http://b4aJettySvr.eai.com.tw:17178" '172.16.10.51 
	'....................................................................
	Public 	reqManager 			As DBRequestManager
	'File.DirDefaultExternal-->/storage/emulated/0/Android/data/{$PkgName}/files
	'/storage/emulated/0/-->Main Storage; Files in working dir won't be cleared
	
	Public	gs_WorkDir 			As String = File.DirDefaultExternal
	'.........................................................................................................................................
	'SQL_ID defined in Jetty web server config.propertities
	'1.Select Distinct top 100 Doc_No,Request_Date,Item_Status From MES_Material_Picking Where Doc_No Like ? And Request_Date Between ? And ?
	'2.Select Doc_No,Request_Date,Item_Status,D.Part_No,Part_Desc,Request_Qty,Unit_Measured,Allowance,Issue_Qty,Issue_Date,Operator_ID,Scale_ID From MES_Material_Picking D,MES_Parts P where Doc_No = ? And D.Part_No=P.Part_No
	'3.UPDATE MES_Material_Picking set Doc_Status=?,Issue_Qty=?,Issue_Date=?,Operator_ID=?,Scale_ID=? where Doc_No=? And Part_No=?
	'.........................................................................................................................................
	Public	gs_SQLID() 			As String = Array As String ( "select_MES_Picking_DocNo","select_MES_Picking","update_MES_Picking")
	Public	SQLite 				As SQL
	Public	Timer1 				As Timer			'For Re-Sync
	Public	gi_Retry_Interval 	As Long = 60		'60 seconds	

	Public	gb_Service_Ready	As Boolean	= False
End Sub

Sub Service_Create			'Will be called only once
	Log("B4A Service is Created")
	ToastMessageShow("Creating service...",True)	
	Starter_Service_Init
	UDP_Service_Init		
	DB_Service_Init			
End Sub

'Service start procedure must complete in 20 seconds.??
Sub Service_Start (StartingIntent As Intent)	
	'Will be invoked when by StartService() or StartServiceAt()
	Log("B4A Service is started")
	
	ToastMessageShow("Service is Starting...",True)	
	'...................................................................................................
	'StartForeground requests Android not to kill this process. Android treat this 
	'App as if it is a visible application and will not kill it.
	'...................................................................................................
	Service.StartForeground(0,Null)			'No notification required
	gb_Service_Ready = True
	CallSub(Main,"CB_Service_Is_Ready")		'call immediately	
End Sub

Sub Service_Destroy		
	'When StopService is called, service won't be running until StartService is called again
	Log("B4A Service is Destroied")
	ToastMessageShow("Service is exiting now...",True)	
	Clean_Up_Service
	CallSub(Main,"CB_Service_Is_Stop")
End Sub

Sub Clean_Up_Service
	Try
		Timer1.Enabled = False			'DB Serivce Timer
		regMgr.SaveReg(gs_RegFile)
		regMgr.ReleaseMap
		UDP_Socket.Close				'UDP Servcie
		SQLite.Close	
	Catch
		ToastMessageShow(LastException.Message,True)
	End Try
	gb_Service_Ready = False
End Sub

Sub Starter_Service_Init		
	ToastMessageShow("System is starting up...",True)
	Dim lb_Reset As Boolean = False
	
	lb_Reset = File.Exists(gs_WorkDir,gs_ResetFlag)
	If  gb_Reset Or lb_Reset Then 			'in case return to original process
		Remove_Working_Files
	'	gb_Reset will be cleared after Reset SQLite
	End If
	eAILib.Initialize
	'Starting servcie
	If  Not(Load_System_Registry(gs_RegFile)) Then
		CallSubDelayed(Main,"Shutdown_Service")
		'will clean up all before stop
	End If

	gs_MyPkgName = eAILib.Get_MyPackageName

	eAILib.gf_Play("ok")	
	Dim msg As String = "Service is started now..." & eAILib.NowStr
	ToastMessageShow(msg,True)
	Log(msg)

End Sub

Sub Remove_Working_Files
	Dim lb_Ok As Boolean = True
	Dim fname(3) As String
	
	fname = Array As String(gs_RegFile,gs_ResetFlag)
	'gs_SQLite_DBname還沒有load進來
	Try
		For idx = 0 To fname.Length - 1
			If  File.Exists(gs_WorkDir,fname(idx)) Then
				If	File.Delete(gs_WorkDir,fname(idx)) Then
					ToastMessageShow("Clear " & fname(idx),True)
				Else
					ToastMessageShow("Can't clear " & fname(idx),True)
					lb_Ok = False
				End If
			End If
		Next
		If 	lb_Ok = False Then 
			ToastMessageShow("Can't reset all working files",True)
		End If
	Catch
		Log(LastException)
	End Try
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'系統參數放在working dir File.DirDefaultExternal 剛安裝時放在Assets目錄
'但不可使用會copy到 working dir,參數更新後寫回去放在 working dir
'重新安裝時必須先殺掉Workdir之參數檔,否則修改參數無效
'Menu("Reset Menu")會清除working dir參數檔
'一概以File.DirDefaultExternal為WorkDir:
'/storage/emulated/0/Android/data/{$PkgName}/files之下
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub Load_System_Registry(regFile As String) As Boolean
	Dim rv As String 
	'..............................................
	'load registries from registry map	
	'regMgr.Initialize(regFile)			'檔案放在 File$File.DirInternal
	'..............................................
	regMgr.Initialize2(regFile,gs_WorkDir)
	
	rv = regMgr.GetRegVal("Debug", "false"): rv = rv.ToLowerCase
	If rv="true" Or rv="yes" Then gb_Debug = True
	
	If regMgr.IsInitialized Then regMgr.Set_Debug_On(gb_Debug)
	If eAILib.IsInitialized Then eAILib.Set_Debug_On(gb_Debug)
		
	gs_Customer		= regMgr.GetRegVal("Customer","")
	gs_SysMenu		= regMgr.GetRegVal("SysMenu", "eAI.MES.eAIMenu1")
	
	gs_BuildID  	= regMgr.GetRegVal("BuildID", "")	'重要版本識別,每次修改程式要更新
	gs_ServerIP		= regMgr.GetRegVal("ServerIP",  "192.168.0.100")
	
	gs_SQLGatewayURL= regMgr.GetRegVal("SQLSvrGateway_URL","http://b4aJettySvr.eai.com.tw:17178")
	
	gs_SQLite_DBname= regMgr.GetRegVal("SQLiteDB","")	
	'..........................
	'Authentication Server
	'..........................
	gs_ServerIP		= regMgr.GetRegVal("ServerIP",  "192.168.0.100")
	gi_ServerPort	= regMgr.GetRegVal("ServerPort", 19500)
	gi_LocalPort	= regMgr.GetRegVal("LocalPort",  19500)

	gs_MyPrinterID	= regMgr.GetRegVal("MyPrinterID","")
	gs_LableFormat	= regMgr.GetRegVal("LabelFormat","SubPkgLabel")
	gi_DaysBefore	= regMgr.GetRegVal("DaysBefore",3)	'Filter Range of days
	gi_DaysAfter	= regMgr.GetRegVal("DaysAfter",10)

	gs_MyScaleID	= regMgr.GetRegVal("MyScaleID","")
	'..........................
	'Get Menu item definitions
	'..........................
	
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	'Global已經宣告 Dim Grp()/App()動態改變 Global Var Dim
	'必須在此重新宣告 (Re-Dimension)
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	'Load App Definition
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Return True
End Sub

Sub Save_RegVaue(key As String, value As String)
	regMgr.SetRegVal(key, value)
End Sub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'
'				ＵＤＰｓｅｒｖｉｃｅ　Fｕｎｃｔｉｏｎｓ
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub UDP_Service_Init
	gb_UDP_Ready = Init_UDP_Connection(gs_ServerIP, gi_ServerPort,gi_LocalPort) 
	If  gb_UDP_Ready = False Then
		Dim msg As String
		msg ="UDP connection is not yet ready for receiving data"
		ToastMessageShow(msg,True)
		Return
	End If
	If gb_Debug Then ToastMessageShow("UDP Service is started:" & gs_ServerIP & "/" & gi_ServerPort & " Listen:" & gi_LocalPort,True)
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Register UDP socket to listen incoming UDP Packets
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub Init_UDP_Connection(as_Server As String, ai_RemotePort As Int, ai_LocalPort As Int) As Boolean
	Dim WiFi As WiFiConnect	
	If	WiFi.IsWiFiEnabled = False Then 
		ToastMessageShow("請開啟無線網路",True)
		Return False
	End If
	
	Try 
		If UDP_Socket.IsInitialized Then UDP_Socket.Close
		UDP_Socket.Initialize("UDP", ai_LocalPort, 1024)	'Android restricted to 1472 bytes for UDP Packet
	Catch
		Dim msg As String
		msg = "Unalbe to initialize UDP Port:[" & ai_LocalPort & "]" &CRLF & LastException
		ToastMessageShow(msg,True)
		Log(msg)
		Return False
	End Try
	
	DoEvents
	Return True
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Callback to Main Module
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub UDP_Set_Callback(cb As CallBackDef) As Boolean
	If  cb = Null Then Return False
	If  SubExists(Main,cb.Callback_SubName) = True Then
		gcb_CallBack = cb
		Return True
	End If
	Return False
End Sub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'UDP Socket Arrived: UTF8 (PB呼叫SDK先轉成ANSI,再轉回來)
'送回PC時也一樣先轉成ANSI PB收到再轉回UTF-8
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub UDP_PacketArrived (Packet As UDPPacket)
    'Packet.Data is ByteArray
	Dim msg As String
	
	If gb_Debug Then ToastMessageShow("Server Ack:" & Packet.HostAddress & "/" & Packet.Port,True)
    msg = BytesToString(Packet.Data, Packet.Offset, Packet.Length, "cp950")
   'Msgbox("Message received: " & msg, "")

	If 	msg.Contains("PrinterList=") Then 
		Handle_Printer_List(msg)
	Else
		Handle_Scale_List(msg)	
	End If
End Sub 
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
'Send a request to MES Server 19501 port
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
Sub Request_Printers_List
	UDP_Send("GetPrinterList")		
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
'Send a request to MES Server 19501 port
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
Sub Request_Scales_List
	UDP_Send("GetScaleList")		
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
'MES Server return current installed printer driver list
'UDP Packet Protocol:
'	$PrinterID1,$PrinterDesc1\t$PrinterID2,$PrinterDesc2\t....
'Data will be Sync SQLite cache 
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
Sub Handle_Printer_List(msg As String) 
	'callback to main module Server Grant Login: format "PrinterList=...."
	Dim Data,Cmd,str1,str2	As String
	Dim ls_PR_Group()		As String

	Cmd="Delete from MES_Printers"
	SQLite.ExecNonQuery(Cmd)
	Cmd="INSERT INTO MES_Printers(PrinterID,PrinterDesc) VALUES(?,?)"
	Data	=	msg.SubString(msg.IndexOf("=")+1)
	ls_PR_Group = eAILib.Get_Tokens(Data,"\t")	'return array	
	
	For Each s As String In ls_PR_Group
		Dim pos As Int
		pos = s.IndexOf(",")
		If  pos = -1 Then
			ToastMessageShow("Invalid Printer in UDP packet(" & s &")[" & Data, True)
			Return
		End If
		str1 = s.SubString2(0,pos)
		str2 = s.SubString(pos+1)
		SQLite.ExecNonQuery2(Cmd, Array As Object(str1,str2) )
	Next
	CallSubDelayed(Main,"CB_Populate_Printer_List")
	If gb_Debug Then ToastMessageShow("Printer Definitions are poulated",True)
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
'MES Server return current installed printer driver list
'UDP Packet Protocol:
'	$PrinterID1,$PrinterDesc1\t$PrinterID2,$PrinterDesc2\t....
'Data will be Sync SQLite cache 
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~`
Sub Handle_Scale_List(msg As String) 
	'callback to main module Server Grant Login: format "PrinterList=...."
	Dim Data,Cmd,str1,str2	As String
	Dim ls_Scale_Group()	As String

	Cmd	= "Delete from MES_Scales"
	SQLite.ExecNonQuery(Cmd)
	Cmd	= "INSERT INTO MES_Scales(ScaleID,ScaleDesc) VALUES(?,?)"
	Data= msg.SubString(msg.IndexOf("=")+1)
	ls_Scale_Group = eAILib.Get_Tokens(Data,"\t")	'return array	
	
	For Each s As String In ls_Scale_Group
		Dim pos As Int
		pos = s.IndexOf(",")
		If  pos = -1 Then
			ToastMessageShow("Invalid Scale in UDP packet(" & s &")[" & Data, True)
			Return
		End If
		str1 = s.SubString2(0,pos)
		str2 = s.SubString(pos+1)
		SQLite.ExecNonQuery2(Cmd, Array As Object(str1,str2) )
	Next
	CallSubDelayed(Main,"CB_Populate_Scale_List")
	If gb_Debug Then ToastMessageShow("Scale Definitions are poulated",True)
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'送回PC時也一樣先轉成ANSI PB收到再轉回UTF-8
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub UDP_Send(as_data As String) As Boolean
	If  gb_UDP_Ready = False Then 
		eAILib.gf_Play("err")
		ToastMessageShow("UDP service is not ready, please send again after restarted",True)
		UDP_Service_Init
		Return False		
	End If
	
	Dim OutBuf() As Byte
	
	OutBuf = Null		'initial value must be set
	OutBuf = as_data.GetBytes("cp950")		'must encode to ANSI

	UDP_Packet.Initialize(OutBuf, gs_ServerIP, gi_ServerPort)
	UDP_Socket.Send(UDP_Packet)
	If gb_Debug Then ToastMessageShow("Sending Message to Server:[" & gs_ServerIP & "] Port:[" & gi_ServerPort & "]",True)
	Return True
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'
' 					ＤＢＳｅｒｖｉｃｅ　  Fｕｎｃｔｉｏｎｓ
'
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub DB_Service_Init
	ToastMessageShow("SQL DB Service is started",True)

	'Debuger不會停在這裡
	'..............................................
	'Starter is APP entry point
	'..............................................		
	Initialize_ReqManager_Remote_SQLServer
	DoEvents	'避免系統認為佔用太長時間出現 Would you like to close it?
	
	Initialize_SQLiteDB
	DoEvents
	
	'...................................................................................................
	'JettyWeb SQL Cmd_ID : 1 SQL defined in config.propertities
	'#commands
	'sql.select_MES_Parts=Select Top 300 Part_No,Part_Desc,Part_Spec FROM MES_Parts WHERE Part_No Like ?
	'...................................................................................................


		
End Sub

Sub Initialize_ReqManager_Remote_SQLServer
	reqManager.Initialize(Me, gs_SQLGatewayURL)
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'1.SQLite無法在AssetDir內執行,必須copy出來到可以I/O的gs_WorkDir目錄
'2.重新安裝時無法刪除gs_WorkDir/xxx.db,因此提供UI Menu-Reset刪除後再重新安裝APK
'3.避免SQLite長期I/O毀損,每隔一天會殺掉gs_WorkDir SQLite db,重新回到出廠設定值
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub Initialize_SQLiteDB
	Dim lb_Copy As Boolean = False
	Dim msg As String
	'File is Located in MAIN Storage/DCIM
	'gs_WorkDir = File.DirRootExternal & "/" & "DCIM"
	msg = ""
	If  Not(File.Exists(gs_WorkDir,gs_SQLite_DBname)) Then
		lb_Copy = True
	Else
		Dim mday, today As Long
		mday = DateTime.DateParse(DateTime.Date(File.LastModified(gs_WorkDir,gs_SQLite_DBname)))
		today= DateTime.DateParse(DateTime.Date(DateTime.Now))
		If ( mday < today ) Then lb_Copy = True	'隔一天就會蓋掉
	End If
	If  lb_Copy Then 
		File.Copy(File.DirAssets,gs_SQLite_DBname,gs_WorkDir,gs_SQLite_DBname)			
		msg = "(Reset to Initial state)"
	End If
	SQLite.Initialize(gs_WorkDir,gs_SQLite_DBname,False)
	'不可以將UI寫在Service因為沒有window
	'Msgbox("SQLite is ready in background Service","Service")
	If gb_Debug Then ToastMessageShow("SQLite is ready..." & msg,True)	
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Execute SQL cmd to Access SQL Server via Jetty Web Server
'Callback to this module : Sub JobDown(Job as HttpJob)
'#SQL commands for Database: Mobile Table:Ship_Order
'SQL.select_MES_Part=Select TOP 100 Part_No, Part_Desc,Part_Spec FROM MES_Parts 
'                      WHERE Part_No Like ?
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub SQL_SELECT(as_Where() As String, CBSub_UI As CallBackDef)
	'ProgressDialogShow("Retrieving data from Remote SQL...")	
	'Service內不可加上UI功能會死當只能用ToastMessageShow()
	If gb_Debug Then ToastMessageShow("Retrieving data from Remote SQL...",True)
		
	Dim SqlCmd 			As DBCommand
	Dim li_TVidx 		As Int
	
	li_TVidx 			= CBSub_UI.TableViewIdx
	SqlCmd.Initialize
	SqlCmd.Name 		= gs_SQLID(li_TVidx)							
	SqlCmd.Parameters	= as_Where 'Array As Object( as_Where )		'use like wild card
	CBSub_UI.rTag		= SqlCmd.Name
	reqManager.ExecuteQuery(SqlCmd,0,CBSub_UI)						'Select Top $Limit;0=不限制
	'Handle Result in JobDone Event	
End Sub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'After completion of execution, it will callback to JobDown Event 
'JobDown是固定名稱, JobName必須是”DBRequest”過濾掉其他不必要
'If  Job.Success = False Then  msg = Job.ErrorMessage ….
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub JobDone(Job As HttpJob)
	Dim Msg 		As String
	Dim CBSub_UI 	As CallBackDef
	Dim li_TVidx 	As Int
		
	If  Job.JobName <> "DBRequest" Then 		'Always return DBRequest from Web Server
		Msg = Job.JobName & " Illegal SQL Job"
		Job.Release
		Log(Msg)
		ToastMessageShow(Msg,True)
		Return
	End If

	If  Job.Success = False Then
		CBSub_UI = Job.Tag
		li_TVidx = CBSub_UI.TableViewIdx		'Table Index
		Msg = CBSub_UI.rTag & " " & Job.ErrorMessage & " Database Error! Retry Sync_SQL_Server is Enabled"
		Log(Msg)
		Job.Release
		CallSub2(Main,"Show_RDC_Connection_Status",False) 'UI變黑
		
		Log(Msg)
		ToastMessageShow(Msg,True)	
		If CBSub_UI.rTag <> gs_SQLID(li_TVidx) Then Enable_Retry_Sync_SQL_Server	'restart timer to retry after N seconds
		'此時 TabeleView已經將資料加入(UPDATE/INSERT/DELETE)
		'SELECT失敗也會啟動如何控制?
		Return
	End If
	
'	CallSub2(Main,"Show_RDC_Connection_Status",True)	'UI亮綠燈

	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	'Take out result then Release Job
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Dim ls_Where	As StrArrType
	Dim rTag		As String
	Dim rowCnt		As Int
	Dim result 		As DBResult 

	result = reqManager.HandleJob(Job)	
	'....................................................................
	'For Non-select result.Rows will hold an array with a single int for 
	'each command. The Int value Is the number of affected rows SqlNrows
	'....................................................................	
	'Decode RDC Tag which is  $TagID;$PrimaryKey
	
	CBSub_UI	= result.Tag		'Tag contains Callback and IDs
	li_TVidx 	= CBSub_UI.TableViewIdx
	rTag		= CBSub_UI.rTag
	
	rowCnt = 0
	If 	rTag <> gs_SQLID(li_TVidx ) Then	'SELECT_Ship_Order
		'Non-Select: SqlNrows -  Number of Rows affected, only 1 row,1 column
		Dim R() As Object			'a row
		R = result.Rows.Get(0)		'Rows is an array of array
		rowCnt = R(0)				'RowCount, SqlNrows
	End If
	
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	'Main UI must define Callback Sub
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	If	rTag = gs_SQLID(li_TVidx) Then	'select_MES_Picking_DocNo
		'1. Get data from Remote SQL and then Insert rows into SQLite
		'2. Load all retrieve from SQLite
		Handle_SELECT_Result(result, li_TVidx)
		'.................................
		'Show retrieved rows on TableView
		'.................................
		If  Not(CBSub_UI.Callback_SubName="") Then
			If 	SubExists(Main,CBSub_UI.Callback_SubName) Then	
				ls_Where = CBSub_UI.args(0)	'where
				'CBSub_UI.args(1)是table class不可宣告變數在service故保持object型態
				CallSub3(Main,CBSub_UI.Callback_SubName,CBSub_UI.args(1),ls_Where)	'Call Load_Data_From_SQLite (where)
			End If
		End If									
	End If
	
	Job.Release

	CallSub2(Main,"Show_RDC_Connection_Status",True)	'UI亮綠燈

End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Handle SELECT Result and show on UI
'Type DBResult(Tag As Object,Columns As Map, Rows As List)
'result.Columns 是 Map, result.Columns.Keys 是IterableList Type,不是List
'
'0 Part_No			varchar(20) Not Null Primary key,
'1 Part_Desc		varchar(80) Null,
'2 Part_Spect		varchar(80) Null
'Remote data will be stored in SQLite1.3 TDCMES.db, then load into TableView
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub Handle_SELECT_Result(result As DBResult, ai_TVidx As Int )
	Dim rowCnt As Int
	Dim Msg As String

	rowCnt = result.Rows.Size
	ToastMessageShow( rowCnt & " rows retrieved",False)
	
	Clean_SQLite_CacheDB(ai_TVidx)
	'Handle Result row by row, Rows is 2D array of Objects
	
	Try
	'	SQLite.BeginTransaction	
	'	An implicit transaction is started automatically(Not by BEGIN)
	'   is committed automatically when the last active statement finishes. 
		For Each record() As Object In result.Rows
			'record is a row of columns value
			'record(1) is Ship_Date datetime column
			'record(5) is Image picture byte array
			'default Trans_Type is 'S' - selected
			Dim Cmd As String
			Select 	Case ai_TVidx
			  Case	Main.gi_TV_SelDoc
					Cmd="INSERT INTO MES_Material_Select_DocNo(Doc_No,Request_Date,Item_Status) VALUES(?,?,?)"
			  Case	Main.gi_TV_SelPart
					Cmd="INSERT INTO MES_Material_Picking(Doc_No,Request_Date,Item_Status,Part_No,Part_Desc,Request_Qty,Unit_Measured,Allowance,Issue_Qty,Issue_Date,Operator_ID,Scale_ID) values(?,?,?,?,?,?,?,?,?,?,?,?)"
			  Case	Else
			  		Msg = "Invalid Table Idx:[" & ai_TVidx & "]"
					Log(Msg)
					ToastMessageShow(Msg,True)					
			  		Return 
			End Select
			'控制同步欄位 Trans_Type, Create_Time用default
			SQLite.ExecNonQuery2(Cmd, Array As Object(record(0),record(1),record(2) ) )
		Next
	'	SQLite.TransactionSuccessful	'Very important,without this,it'll rollback all trx
	 Catch 
		Msg = "Insert SQLite Error" & LastException.Message
		ToastMessageShow(Msg,True)
		Log(Msg)
	End Try
	'SQLite.EndTransaction		
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Clean CacheDB by removing previous download rows w/o touched 
'OR updated rows which has been alreay Sync with Remove SQL Server
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub Clean_SQLite_CacheDB(ai_TVidx As Int)
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	'Remove rows Retrieved from SQLserver and left intact
	'Timer will be turn-on to sync with Remote SQL Server, if previous RDC SQL failed 
	'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Dim ls_Cmd As String
	Select 	Case ai_TVidx
	  Case	Main.gi_TV_SelDoc
			ls_Cmd="Delete from MES_Material_Select_DocNo"
	  Case	Main.gi_TV_SelPart
			ls_Cmd="Delete from MES_Material_Picking"
	  Case	Else
	  		Msg = "Invalid Table Idx:[" & ai_TVidx & "]"
			Log(Msg)
			ToastMessageShow(Msg,True)					
	  		Return 
	End Select
	Try
		SQLite.BeginTransaction
		'Remove previous download rows w/o touched or alreay Sync with Remove SQL Server
		SQLite.ExecNonQuery(ls_Cmd)	
		SQLite.TransactionSuccessful	'Very important,without this,it'll rollback all trx
	 Catch 
	    Dim Msg As String
		Msg = "Delete SQLite Error" & LastException.Message
		ToastMessageShow(Msg,True)
		Log(Msg)
	End Try
	SQLite.EndTransaction
End Sub
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'1. Successful Sync with Remote SQL Server will be removed from local cached
'   SQLite. except that Newly insert row will be kept and with status 'S' the 
'   same As Selected Rows from SQL Server
'2. If RDC unable to update Remote SQL Server, SQLite Table 
'   Trans_Type='I' or 'U' or 'D' (Insert/Update/Delete)
'   Timer will be started to execute RDC job again until succeed
'3. Only Trans_Type = 'S' will be displayed on TableVie
'4. Retry_Sync_SQL_Server will be fired by Timer Event
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub Enable_Retry_Sync_SQL_Server
	ToastMessageShow("Timer is enalbed to retry-Sync with Remote SQL Server...Wait " & gi_Retry_Interval & "seconds",True)
	Timer1.Initialize("TIMER1",gi_Retry_Interval)
End Sub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'Start ReSync cycle every gi_Retry_Interval seconds
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub TIMER1_Tick
	If  reqManager.IsInitialized Then
		Retry_Sync_SQL_Server
	Else
		Enable_Retry_Sync_SQL_Server
	End If
End Sub

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'In case of network failure, reSync from remote SQL
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Sub Retry_Sync_SQL_Server
'	Clean_SQLite_CacheDB
'	暫不考慮
'	CallSubDelayed2(Main,"Select_SQL_Server_MES_Parts", Array As Object(Main.gs_Last_Filter), )
	Timer1.Enabled = False	
	'Turn off Timer.. if failed again, JobDone event will Turn it on again
End Sub

